﻿using System;
using CSGenICam.CSI;
using CSGenICam;

class DemoProgram
{
    static unsafe void Main(string[] args)
    {
        var lib = new Library();
        // Use this example to point to a specific GenTL producer file,
        //lib.Options.AdditionalSearchPaths.Add(@"C:\GenTL");
        //lib.Options.UseAdditionSearchPathsOnly = true;

        // Run discovery and check for available devices
        if(lib.Discovery.Cameras.Count > 0) {
            // Use the first device in the list
            var cam = lib.Discovery.Cameras[0];

            // Register for incoming NewImage events
            cam.DataStreams[0].Register((sender, evt) => 
            {
                System.Console.WriteLine("New image received!" + evt.Data.ImageNr);
                // Release data
                evt.ReleaseData();
            });

            // Example for setting and getting of features. This API will change in future!
            csi.SetFeatureInt(cam.NativeHandle, "Width", 1024, CsiModuleLevel.CSI_DEVICE_MODULE);
            long Width = 0;
            csi.GetFeatureInt(cam.NativeHandle, "Width", ref Width, CsiModuleLevel.CSI_DEVICE_MODULE);
            cam.StartAcquisition();

            // Let acquisition run for 3 seconds and stop afterwards
            System.Threading.Thread.Sleep(3000);
            cam.StopAcquisition();

            // Close camera
            cam.Close();
        }
    }

    public static void LogFunc(CsiLogLevel ll, string message, IntPtr userdata)
    {

    }
}
